<?php
/**
 * GetCorporationCorporationIdMiningObservers200Ok
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swaagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * EVE Swagger Interface
 *
 * An OpenAPI for EVE Online
 *
 * OpenAPI spec version: 0.7.3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;

/**
 * GetCorporationCorporationIdMiningObservers200Ok Class Doc Comment
 *
 * @category    Class
 * @description 200 ok object
 * @package     Swagger\Client
 * @author      Swagger Codegen team
 * @link        https://github.com/swagger-api/swagger-codegen
 */
class GetCorporationCorporationIdMiningObservers200Ok implements ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      * @var string
      */
    protected static $swaggerModelName = 'get_corporation_corporation_id_mining_observers_200_ok';

    /**
      * Array of property to type mappings. Used for (de)serialization
      * @var string[]
      */
    protected static $swaggerTypes = [
        'last_updated' => '\DateTime',
        'observer_id' => 'int',
        'observer_type' => 'string'
    ];

    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of attributes where the key is the local name, and the value is the original name
     * @var string[]
     */
    protected static $attributeMap = [
        'last_updated' => 'last_updated',
        'observer_id' => 'observer_id',
        'observer_type' => 'observer_type'
    ];


    /**
     * Array of attributes to setter functions (for deserialization of responses)
     * @var string[]
     */
    protected static $setters = [
        'last_updated' => 'setLastUpdated',
        'observer_id' => 'setObserverId',
        'observer_type' => 'setObserverType'
    ];


    /**
     * Array of attributes to getter functions (for serialization of requests)
     * @var string[]
     */
    protected static $getters = [
        'last_updated' => 'getLastUpdated',
        'observer_id' => 'getObserverId',
        'observer_type' => 'getObserverType'
    ];

    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    public static function setters()
    {
        return self::$setters;
    }

    public static function getters()
    {
        return self::$getters;
    }

    const OBSERVER_TYPE_STRUCTURE = 'structure';
    

    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public function getObserverTypeAllowableValues()
    {
        return [
            self::OBSERVER_TYPE_STRUCTURE,
        ];
    }
    

    /**
     * Associative array for storing property values
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     * @param mixed[] $data Associated array of property values initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['last_updated'] = isset($data['last_updated']) ? $data['last_updated'] : null;
        $this->container['observer_id'] = isset($data['observer_id']) ? $data['observer_id'] : null;
        $this->container['observer_type'] = isset($data['observer_type']) ? $data['observer_type'] : null;
    }

    /**
     * show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalid_properties = [];

        if ($this->container['last_updated'] === null) {
            $invalid_properties[] = "'last_updated' can't be null";
        }
        if ($this->container['observer_id'] === null) {
            $invalid_properties[] = "'observer_id' can't be null";
        }
        if ($this->container['observer_type'] === null) {
            $invalid_properties[] = "'observer_type' can't be null";
        }
        $allowed_values = ["structure"];
        if (!in_array($this->container['observer_type'], $allowed_values)) {
            $invalid_properties[] = "invalid value for 'observer_type', must be one of 'structure'.";
        }

        return $invalid_properties;
    }

    /**
     * validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['last_updated'] === null) {
            return false;
        }
        if ($this->container['observer_id'] === null) {
            return false;
        }
        if ($this->container['observer_type'] === null) {
            return false;
        }
        $allowed_values = ["structure"];
        if (!in_array($this->container['observer_type'], $allowed_values)) {
            return false;
        }
        return true;
    }


    /**
     * Gets last_updated
     * @return \DateTime
     */
    public function getLastUpdated()
    {
        return $this->container['last_updated'];
    }

    /**
     * Sets last_updated
     * @param \DateTime $last_updated last_updated string
     * @return $this
     */
    public function setLastUpdated($last_updated)
    {
        $this->container['last_updated'] = $last_updated;

        return $this;
    }

    /**
     * Gets observer_id
     * @return int
     */
    public function getObserverId()
    {
        return $this->container['observer_id'];
    }

    /**
     * Sets observer_id
     * @param int $observer_id The entity that was observing the asteroid field when it was mined.
     * @return $this
     */
    public function setObserverId($observer_id)
    {
        $this->container['observer_id'] = $observer_id;

        return $this;
    }

    /**
     * Gets observer_type
     * @return string
     */
    public function getObserverType()
    {
        return $this->container['observer_type'];
    }

    /**
     * Sets observer_type
     * @param string $observer_type The category of the observing entity
     * @return $this
     */
    public function setObserverType($observer_type)
    {
        $allowed_values = array('structure');
        if ((!in_array($observer_type, $allowed_values))) {
            throw new \InvalidArgumentException("Invalid value for 'observer_type', must be one of 'structure'");
        }
        $this->container['observer_type'] = $observer_type;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     * @param  integer $offset Offset
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     * @param  integer $offset Offset
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     * @param  integer $offset Offset
     * @param  mixed   $value  Value to be set
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     * @param  integer $offset Offset
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this), JSON_PRETTY_PRINT);
        }

        return json_encode(\Swagger\Client\ObjectSerializer::sanitizeForSerialization($this));
    }
}


